<?php

   $RGBColorsTable =  RGB_Colors_Table();

   $cYear = date('Y');

   print <<< _HTML

<!DOCTYPE HTML>

<HTML lang='en'>
<head>

<title>HTML/CSS Color Names and Codes</title>
<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='HTML/CSS RGB Color Names, HEX, Decimal and Composite Color Codes and How to Compute RGB Values'>
<meta name='keywords' content='RGB values,compute RGB,calculate RGB,HEX code,RGB code,composite color code'>
<meta name='author' content='Jay Tanner - PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>

<style type='text/css'>
 TD
{
 color:silver; background:black; font-family:verdana; font-size:110%;
 font-weight:normal; padding:8px; border:1px solid #222222;
 letter-spacing:2px; text-align:center;
}

 PRE
{
 background:white; color:black;  font-family:monospace; font-size:120%;
 font-weight:bold; padding:8px; border-radius:8px;
}

::selection {color:black; background:yellow;}
::-moz-selection {color:black; background:yellow;}
</style>

</head>

<body style='background:black;'>

<div ID='SmoothScroll'>
<table align='top' cellspacing='0'>
$RGBColorsTable

<tr><td colspan='5'>&nbsp;</td></tr>
<tr><td colspan='5'>&nbsp;</td></tr>
<tr><td colspan='5' style='text-align:center;'>
<pre style='text-align:left; color:white; background:#002200; border:2px solid lime; border-radius:8px;'>
               HTML/CSS/COMPOSITE/DECIMAL AND HEX RGB COLOR CODES
        ==============================================================

         COLOR_COMPONENT   DECIMAL   HEXADECIMAL         BINARY
        -----------------  --------  -----------  --------------------
         R = Red level     0 to 255   00 to FF    00000000 to 11111111
         G = Green level   0 to 255   00 to FF    00000000 to 11111111
         B = Blue level    0 to 255   00 to FF    00000000 to 11111111

         On an RGB monitor display, every color on the screen is made
         up of various combinations of intensity levels of red, green
         and blue.

         Each RGB level means the intensity or brightness level of the
         individual RGB colors, where each RGB color has 256 levels of
         brightness from 0 to 255, and can be combined to create over
         16 million total possible shades or colors.

         More precisely:

         Since there are 3 primary colors, Red, Green and Blue and 256
         possible intensity values for each RGB color:

         Let:
         p = 3   = Number of primary colors
         b = 8   = Number of binary bits per primary color
         N = 256 = Number of color intensity levels

         Each RGB composite value = R+G+B = 8+8+8 = 24 binary bits

         T = Total possible composite RGB color codes
           = (N ^ p)    =  256 ^ 3
           = (2 ^ p*b)  =  2^(3*8)  =  2 ^ 24
           =  16,777,216

         Maximum decimal value of binary integer = (2 ^ bits) &minus; 1
         In the context of 8-bit RGB values:
         The maximum decimal value of RGB code = (2 ^ b) &minus; 1
                                               = (2 ^ 8) &minus; 1
                                               =  256 &minus; 1
                                               =  255

         -------------------------------------------------------------
            Given the decimal (R,G,B) color levels, the corresponding
            composite color code (C) value can be computed by:

            C = R*65536 + G*256 + B

            The composite color (C) values range from 0 to 16777215.

            The composite color value acts like a sequential serial
            number for each of the exactly 16,777,216 shades of the
            RGB spectrum, from 0=Black to 16777215=White and all
            the other 16,777,213 RGB shades in between.

         -------------------------------------------------------------
            Given the composite color code (C), the corresponding
            decimal (R,G,B) levels can be extracted by using the
            following formulas, where:

            R = floor(C / 65536)
            B = C mod 256
            G = floor((C &minus; R*65536 &minus; B) / 256)

         -------------------------------------------------------------
               NEGATIVE or INVERSE RGB and COMPOSITE COLOR CODES

            To obtain the negative or inverse of an RGB color
            simply subtract each of its RGB levels from 255.

            Inv(R,G,B) = rgb(255&minus;R, 255&minus;G, 255&minus;B)



            For the negative or inverse of a composite value (C),
            simply subtract the composite value from 16777215.

            InvCompositeValue = 16777215 &minus; C

         -------------------------------------------------------------


</pre>
<span style='font-size:80%; text-align:center;'>Table Created by Jay Tanner - $cYear</span>
</td></tr>
</table>

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>
<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

</div>


<script src='Smooth_Scroll.js'></script>
<script>SmoothScroll.init({cancelOnTouch: true});</script>

</body>

</HTML>

_HTML;





   function RGB_Colors_Table()
{
/*
   Get data file and count total text data lines to be processed.
   Each line is a text data string, but not every line necessarily
   is a data line.  Here, a line is only a data line if it begins
   with a pound or hash (#) symbol.  Otherwise it is treated as a
   comment line and ignored.
*/
   $DataLines = file("color-codes.data");
   $DataLinesCount = count($DataLines);

// ---------------------------------------------------
// Process text data file lines to create ColorsTable.

   $ColorsTableBody = "";

   for ($i=0;  $i < $DataLinesCount;   $i++)
  {
// Get current data line.
   $DataLine = trim($DataLines[$i]);

// Process ONLY data lines starting with a
// with a pound or hash (#) symbol.  Treat
// all other text lines as comments.

   if (substr($DataLine, 0,1) == '#')
  {
   $HexValue  = substr($DataLine, 1,6);

   $HEXCode   = '#' . $HexValue;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// Get HEX color-code values.
   $xR = substr($HexValue, 0, 2);
   $xG = substr($HexValue, 2, 2);
   $xB = substr($HexValue,   -2);

   $xR = "<span style='color:DeepPink;'>$xR</span>";
   $xG = "<span style='color:lime;'>$xG</span>";
   $xB = "<span style='color:DodgerBlue;'>$xB</span>";
   $xHexValue = "$xR$xG$xB";

   $xHEXCode   = '#' . $xHexValue;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




// Get color name text string.
   $ColorName = trim(substr($DataLine, 8, strlen($DataLine)));

// Compute decimal RGB values corresponding to
// the HEX values and construct rgb(...) string.
   $R = HexDec(substr($HexValue, 0,2));
   $G = HexDec(substr($HexValue, 2,2));
   $B = HexDec(substr($HexValue, 4,2));
   $RGBCode = "rgb($R,$G,$B)";

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
   $xR = "<span style='color:DeepPink;'>$R</span>";
   $xG = "<span style='color:lime;'>$G</span>";
   $xB = "<span style='color:DodgerBlue;'>$B</span>";
   $RGBCode = "rgb($xR, $xG, $xB)";
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


// Compute RGB composite color
// C = Integer in the range from 0 to 16777215.
   $C = 65536*$R + 256*$G + $B;

// Construct current output HTML ColorsTable line.
   $ColorsTableBody .= "<tr><td style='background:#$HexValue;'>&nbsp;<br><br></td><td style='text-align:left;'>$ColorName</td><td style='letter-spacing:1px; color:silver;'>#$xHexValue</td><td style='letter-spacing:1px; color:silver; text-align:center;'>$RGBCode</td><td style='text-align:center; letter-spacing:1px; color:silver;'>$C</td></tr>\n";
  }
  }

   $dRGB = "<span style='color:DeepPink;'>R<span style='color:white;'>,</span></span><span style='color:lime;'>G</span><span style='color:white;'>,</span><span style='color:DodgerBlue;'>B</span>";

   $hRGB = "<span style='color:white;'>#</span><span style='color:DeepPink;'>R</span><span style='color:lime;'>G</span><span style='color:DodgerBlue;'>B</span>";

// Construct HTML colors table title row.
   $ColorsTableTitle = "<tr><td colspan='5' style='color:white; background:#000066; font-family:Verdana; font-size:125%; font-weight:normal; border:2px solid white; border-radius:8px 8px 0px 0px; line-height:150%; text-align:center;'>Table of 140 Standard Color Names/HTML/CSS/HEX/RGB/COMPOSITE Codes<br><span style='font-size:85%;'>Color Names and HEX RGB Codes Are NOT Case Sensitive in HTML/CSS</span><br><span style='font-size:70%;'>Colors Table Created by Jay Tanner - 2022</span><br><span style='font-size:70%;'><b>Caveat</b>:&nbsp;<i>Not all RGB monitors agree on how their colors appear, only on their RGB codes.</i></span></td></tr><tr><td colspan='5'>&nbsp;</td></tr>\n";

// Construct HTML table column headers and footers row.
   $ColumnsHeader = $ColumnsFooter = "<tr>
   <td style='letter-spacing:2px; color:white; background:#181818; text-align:center;' width='256'>COLOR&nbsp;SAMPLE</td><td style='color:white; background:#181818;  text-align:left;'>COLOR&nbsp;NAME</td><td style='color:white; background:#181818; text-align:center;'>HEX&nbsp;$hRGB</td><td style='color:white; background:#181818; text-align:center;'>DECIMAL&nbsp;$dRGB</td><td style='color:white; background:#181818;'>COMPOSITE</td></tr>\n";

// Construct and return finished HTML colors table
// rows structure sans table start and end tags.
// A table should be created to hold this returned
// 5-column by 141 row structure.
   return "$ColorsTableTitle$ColumnsHeader$ColorsTableBody$ColumnsFooter";
}


?>








